/**
 * Copyright (C), 2021-2021, 夸克科技有限公司
 * FileName: IRecognizeContract
 * Author: Administrator
 * Date: 2021/10/28 10:32
 * Description: 契约类
 * History:
 * <author> <time> <version> <desc>
 * 作者姓名 修改时间 版本号 描述
 */
package quake.quake_tensorflow_face_rec.detection.mvp.contract;

import android.app.Activity;
import android.content.Context;
import android.database.sqlite.SQLiteDatabase;

import org.json.JSONObject;

import quake.quake_tensorflow_face_rec.baseMvp.IBasePresenter;
import quake.quake_tensorflow_face_rec.baseMvp.IBaseView;
import quake.quake_tensorflow_face_rec.detection.tflite.SimilarityClassifier;


/**
 * @ClassName: IRecognizeContract
 * @Description: interface接口作用描述
契约类
 * @Author: Administrator
 * @Date: 2021/10/28 10:32
 */
public interface IRecognizeContract {
    interface View extends IBaseView {

    }
    interface Presenter extends IBasePresenter<View> {
        void registerFace(SimilarityClassifier detector, SQLiteDatabase db, Context context);
        void registerFace(JSONObject faceInfo,SimilarityClassifier detector);
        void initDetector();




        /**
         * 构造检测器，利用TensorFlow训练出来的Model，也就是.tflite文件。这是后面人脸检测的关键
         * @param context
         * @param activity
         * @return
         */
        SimilarityClassifier createClassifier(Context context,Activity activity);
    }
}
