/**
 * Copyright (C), 2021-2021, 夸克科技有限公司
 * FileName: RecognizePresenter
 * Author: Administrator
 * Date: 2021/10/28 10:34
 * Description:
 * History:
 * <author> <time> <version> <desc>
 * 作者姓名 修改时间 版本号 描述
 */
package quake.quake_tensorflow_face_rec.detection.mvp.presenter;

import android.app.Activity;
import android.content.Context;
import android.database.sqlite.SQLiteDatabase;


import org.json.JSONObject;

import java.util.List;

import quake.quake_tensorflow_face_rec.baseMvp.BasePresenter;
import quake.quake_tensorflow_face_rec.detection.mvp.contract.IRecognizeContract;
import quake.quake_tensorflow_face_rec.detection.mvp.model.RecognizeModel;
import quake.quake_tensorflow_face_rec.detection.tflite.SimilarityClassifier;


/**
 * @ClassName: RecognizePresenter
 * @Description: java类作用描述

 * @Author: Administrator
 * @Date: 2021/10/28 10:34
 */
public class RecognizePresenter extends BasePresenter<IRecognizeContract.View, RecognizeModel> implements IRecognizeContract.Presenter {


    @Override
    public void registerFace(SimilarityClassifier detector, SQLiteDatabase db, Context context) {
        List<SimilarityClassifier.Recognition> mapRecognition = mModel.getSqlFaceData(db,context);
        if(mapRecognition!=null){
            detector.register(mapRecognition.get(0).getId(), mapRecognition.get(0));
        }
    }

    @Override
    public void registerFace(JSONObject faceInfo,SimilarityClassifier detector) {
        String worker_id = faceInfo.optString("worker_id");
        String tfFaceFeature = faceInfo.optString("tfFaceFeature");
        List<SimilarityClassifier.Recognition> mapRecognition = mModel.getFaceInfo(worker_id,tfFaceFeature);
        if(mapRecognition!=null){
            detector.register(mapRecognition.get(0).getId(), mapRecognition.get(0));
        }
    }

    @Override
    public void initDetector() {

    }



    @Override
    public SimilarityClassifier createClassifier(Context context,Activity activity) {
        return mModel.getClassifier(context,activity);
    }
}
