package quake.quake_tensorflow_face_rec.ui.CustomView;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.view.View;

public class RoundView extends View {
    private int  mWidth;
    private String text;

    public RoundView(Context context, int mWidth,String text) {
        super(context);
        this.mWidth = mWidth;
        this.text = text;
    }

    public RoundView(Context context) {
        super(context);

    }



    @Override
    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
        int centreX = getWidth() / 2;
        int centreY = getHeight() / 2;
        int radius = mWidth / 2;

        Paint mPaint = new Paint();
        mPaint.setColor(0xff828891);
        mPaint.setAntiAlias(true);
        mPaint.setStyle(Paint.Style.FILL);

        canvas.drawCircle(centreX,centreY,centreY,mPaint);


        Paint textPaint = new Paint();
        textPaint.setColor(0xffffffff);
        textPaint.setTextSize(30);
        textPaint.setTextAlign(Paint.Align.CENTER);
        Paint.FontMetrics fontMetrics = textPaint.getFontMetrics();
        float top = fontMetrics.top;
        float bottom = fontMetrics.bottom;
        float baseLineY = centreY +-top/2-bottom/2;

        canvas.drawText(text,centreX,baseLineY,textPaint);
        postInvalidate();
    }
}
