package quake.quake_tensorflow_face_rec.utils;

import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.StrictMode;
import android.text.TextUtils;
import android.util.Log;


import androidx.viewbinding.BuildConfig;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;

public class DatabaseUtils {
    private HashMap<String, ArrayList<BigDecimal[]>> arrayList;
    private BigDecimal[] bigDecimals;
    private String worker_id;
    public DatabaseUtils(){

    }
    public DatabaseUtils(String id, BigDecimal[] bigDecimals){
        this.worker_id = id;
        this.bigDecimals = bigDecimals;
    }
    public String getWorker_id(){
        return worker_id;
    }
    public BigDecimal[] getBigDecimals(){
        return bigDecimals;
    }
    public HashMap<String, ArrayList<BigDecimal[]>> getArrayList(){
        return arrayList;
    }
    public void setWorker_id(String worker_id){
        this.worker_id = worker_id;
    }
    public void setBigDecimals(BigDecimal[] bigDecimals){
        this.bigDecimals = bigDecimals;
    }

    public void setArrayList(HashMap<String, ArrayList<BigDecimal[]>> arrayList) {
        this.arrayList = arrayList;
    }

    //把String转化为double
    public static double convertToDouble(String number, double defaultValue) {
        if (TextUtils.isEmpty(number)) {
            return defaultValue;
        }
        try {
            return Double.parseDouble(number);
        } catch (Exception e) {
            return defaultValue;
        }

    }

    public static float[][] string2floatArray(String string){
        Log.d("string2float","string="+string);
        String result = string.replaceAll(" ","");
        result = DataConvertion.deleteString(result,'[');
        String[] s = DataConvertion.string2Array(result,"],");
        float[][] embeddings =  new float[1][192];
        for (int i = 0;i<s.length;i++){
            String[] ss = DataConvertion.string2Array(s[i], ",");
            for (int j = 0; j < ss.length; j++) {
                ss[j] = DataConvertion.deleteString(ss[j], ']');
                float f = Float.parseFloat(ss[j]);
//                bigDecimals = new BigDecimal[ss.length];
//                bigDecimals[j] = new BigDecimal(ss[j]);
                Log.d("string2float","face="+f);

                embeddings[0][j] = f;
//                Arrays.fill(embeddings[0], f);
                Log.d("embeddings","embeddings="+embeddings[0]);
            }
        }
        return embeddings;
    }
    public static BigDecimal[] searchFace(SQLiteDatabase db, String tableName, String column) {

        Cursor cursor = db.query(tableName, new String[]{column}, null, null, null,
                null, null, null);
        String result;
        BigDecimal[] bigDecimals = new BigDecimal[0];
        while (cursor.moveToNext()) {
            result = cursor.getString(4).replaceAll(" ","");
            result = DataConvertion.deleteString(result, '[');
//            result = DataConvertion.deleteString(result,']');
            Log.d("searchFace", "第"+(cursor.getPosition()+1)+"个员工: " + result);
            String[] s = DataConvertion.string2Array(result, "],");
            for (int i = 0; i < s.length; i++) {
                String[] ss = DataConvertion.string2Array(s[i], ",");
                Log.d("searchFace", "第"+(cursor.getPosition()+1)+"个员工的第" + (i + 1) + "组特征向量 :" + s[i]);
                for (int j = 0; j < ss.length; j++) {
                    ss[j] = DataConvertion.deleteString(ss[j], ']');

                    bigDecimals = new BigDecimal[ss.length];
                    bigDecimals[j] = new BigDecimal(ss[j]);
                    Log.d("searchFace", "第"+(cursor.getPosition()+1)+"个员工的第" + (i + 1) + "组特征向量的第" + (j + 1) + "个特征向量 :" + bigDecimals[j]);
                }
            }
        }
        cursor.close();
        return bigDecimals;
    }

    //检查表是否存在以及是否是空表
    public static boolean sqlTableIsExist(SQLiteDatabase db, String tableName) {

        boolean a = false;
        Cursor cursor = null;
        if (BuildConfig.DEBUG) {
            StrictMode.setVmPolicy(new StrictMode.VmPolicy.Builder()
                    .detectLeakedSqlLiteObjects()
                    .detectLeakedClosableObjects()
                    .penaltyLog()
                    .penaltyDeath()
                    .build());
        }
        try{
            cursor = db.rawQuery("select name from SQLITE_MASTER where type='table'", null);
            Log.i("cursor.getCount()", "cursor.getCount():" + cursor.getCount());

            while (cursor.moveToNext()) {
                Log.i("System.out", "cursor.getCount:" + cursor.getCount());
                //遍历出表名
                String name = cursor.getString(0);
                if (name.equals(tableName)) {
                    //找到表
                    a = true;
                }
                Log.i("System.out", "表名:" + name);
            }
            if (a) {
                    Cursor cursor1 = null;
                try{
                    cursor1 = db.query(tableName, null, null, null, null, null, null);

                    if (cursor.getCount() > 0) {
                        Log.i("cursor1", "行数：" + cursor.getCount() + "");
                        return true;
                    } else {
                        Log.i("cursor2", "行数：" + cursor.getCount() + "");
                        return false;
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }finally {
                    if(cursor1!=null){
                        cursor1.close();
                    }
                }

                //检查是不是空表

            } else {
                //没找到表
                Log.i("cursor3", "行数：" + cursor.getCount() + "");
                return false;
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        finally {
            if(cursor!=null){
                cursor.close();
                Log.i("sqlTableIsExist", "cursor：" + cursor.isClosed());
            }
        }

        return false;
    }
    //删除表
    public static void deleteTable(SQLiteDatabase db, String tableName) {
        db.execSQL("delete from " + tableName);
//        db.execSQL("update sqlite_sequence set seq=0 where name='"+tableName+"'");
        db.execSQL("delete from sqlite_sequence where name = '" + tableName + "'");
    }
/*    public void saveFace(SQLiteDatabase db,String tableName){
        Cursor cursor = db.query(tableName,)
    }*/
}
