package quake.quake_tensorflow_face_rec.utils;/*
* FileName: MyDatabaseHelper
 4 * Author: Administrator
 5 * Date: 2021/5/12 11:20
 6 * Description: 
*/

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

import androidx.annotation.Nullable;

public class MyDatabaseHelper extends SQLiteOpenHelper {
    /*    public static final String CREATE_STUDENT = "create table Student("
                + "id integer primary key autoincrement,"
                + "name text," +
                "number text)";*/
    private static final String TAG = "MyDatabaseHelper";

    public MyDatabaseHelper(@Nullable Context context) {
        super(context, Constants.DATABASE_NAME, null, Constants.VERSION_CODE);
    }

    /**
     * Called when the database is created for the first time.
     * 第一次创建数据库的时候被调用
     *
     * @param db
     */
    @Override
    public void onCreate(SQLiteDatabase db) {
        //创建时的回调
        Log.d(TAG, "创建数据库。。。");
        //创建字段
        //sql create table table_name(_id int integer,name varchar(50),age integer,
        // salary integer);
   /*     String sql = "create table " + Constants.TABLE_NAME + "(_id integer,name varchar," +
                "age integer,salary integer)";
        db.execSQL(sql);
*/

        //创建人脸会员表
        String sqlVIP = "CREATE TABLE IF NOT EXISTS faceVIP (" +
                "id                     INTEGER PRIMARY KEY AUTOINCREMENT    NOT NULL," +
                "worker_id              VARCHAR(50)      NOT NULL," +
                "FaceID                 VARCHAR(50)      NOT NULL," +
                "tfFaceFeature            TEXT             NOT NULL," +
                "PhoneNum               VARCHAR(100)     NOT NULL," +
                "Profile                INTEGER          NOT NULL)";
        //创建员工表
        String sqlWorker = "CREATE TABLE IF NOT EXISTS workerFace (" +
                "id                         INTEGER PRIMARY KEY AUTOINCREMENT        NOT NULL," +
                "source                     VARCHAR(10)      NOT NULL," +
                "worker_id                  VARCHAR(10)      NOT NULL," +
                "worker_name                TEXT             NOT NULL," +
                "tfWorkerFace               TEXT             NOT NULL," +
                "dept                       VARCHAR(50)      NOT NULL," +
                "phone                      VARCHAR(50)      NOT NULL," +
                "avatar                     VARCHAR(100)     NOT NULL," +
                "guid                       VARCHAR(50)      NOT NULL)";
//        String sqlWorker = "CREATE TABLE IF NOT EXISTS workerFace (" +
//                "id                         INTEGER PRIMARY KEY AUTOINCREMENT        NOT NULL," +
//                "source                     VARCHAR(10)      ," +
//                "worker_id                  VARCHAR(10)      ," +
//                "worker_name                TEXT             ," +
//                "tfWorkerFace               TEXT             DEFAULT 'null'," +
//                "dept                       VARCHAR(50)      ," +
//                "phone                      VARCHAR(50)      NOT NULL," +
//                "avatar                     VARCHAR(100)     ," +
//                "guid                       VARCHAR(50)      )";
        //创建考勤记录表
        String sqlAttendanceRecord = "CREATE TABLE IF NOT EXISTS IO_record(" +
                "id                     INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL," +
                "uid                    VARCHAR(50)      NOT NULL," +
                "dept                   VARCHAR(10)      NOT NULL," +
                "worker_id              VARCHAR(10)      NOT NULL," +
                "time_record            VARCHAR(50)      NOT NULL," +
                "camera_num             VARCHAR(50)      NOT NULL," +
                "type                   VARCHAR(10)      NOT NULL," +
                "isUpload               INTEGER          NOT NULL," +
                "profile                VARCHAR(200)     NOT NULL," +
                "isSave                 INTEGER          NOT NULL)";
        //创建所有员工排班表
        String sqlSchedule = "CREATE TABLE IF NOT EXISTS workerSch (" +
                "id                     INTEGER PRIMARY KEY AUTOINCREMENT    NOT NULL," +
                "dept                   VARCHAR(10)      NOT NULL," +
                "worker_id              VARCHAR(10)      NOT NULL," +
                "name                   VARCHAR(50)      NOT NULL," +
                "workTime               VARCHAR(50)      NOT NULL," +
                "schName                VARCHAR(10)      NOT NULL)";
//        // 创建考勤图像存储地址信息表
//        String sqlImageStorageAddress = "CREATE TABLE IF NOT EXISTS recordPics (" +
//                "id                     INTEGER PRIMARY KEY AUTOINCREMENT    NOT NULL," +
//                "dept                   VARCHAR(10)      NOT NULL," +
//                "uid                    VARCHAR(50)      NOT NULL," +
//                "worker_id              VARCHAR(10)      NOT NULL," +
//                "time_record            VARCHAR(50)      NOT NULL," +
//                "profile                VARCHAR(200)     NOT NULL," +
//                "isSave                 INTEGER          NOT NULL," +
//                "isUpload               INTEGER          NOT NULL)";
        db.execSQL(sqlVIP);
        db.execSQL(sqlWorker);
        db.execSQL(sqlSchedule);
        db.execSQL(sqlAttendanceRecord);
//        db.execSQL(sqlImageStorageAddress);


    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        //升级数据库的回调
        Log.d(TAG, "升级数据库。。。");

        //sql:alter table table_name add phone integer;
        /*String sql;

        switch (oldVersion) {
            case 1:
                //添加address phone 字段
                sql = "alter table " + Constants.TABLE_NAME + " add column phone integer";
                db.execSQL(sql);
                sql = "alter table " + Constants.TABLE_NAME + " add column address varchar";
                db.execSQL(sql);
                break;
            case 2:
                //添加address phone 字段
                sql = "alter table " + Constants.TABLE_NAME + " add address varchar";
                db.execSQL(sql);
                break;
            case 3:
                break;
        }*/
    }
}
