package quake.quake_tensorflow_face_rec.utils;

import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.RectF;
import android.util.AttributeSet;
import android.util.TypedValue;
import android.view.View;

import quake.quake_tensorflow_face_rec.R;


public class RunningRing extends View {
    private int mColorFirst;
    private int mColorSecond;
    private int mSpeed;
    private int mRingWidth;

    private boolean isNext;
    private int mProgress;
    private Paint mPaint;

    public RunningRing(Context context){
        this(context,null);
    }

    public RunningRing(Context context, AttributeSet attrs){
        this(context,attrs,0);
    }
    public RunningRing(Context context,AttributeSet attrs,int defStyleAttr){
        super(context,attrs,defStyleAttr);
        TypedArray typedArray = context.obtainStyledAttributes(attrs, R.styleable.RunningRing,defStyleAttr,0);
        int n = typedArray.getIndexCount();
        for (int i = 0;i<n;i++){
            int attr = typedArray.getIndex(i);
            if (attr == R.styleable.RunningRing_colorFirst) {
                mColorFirst = typedArray.getColor(attr, Color.BLACK);
            } else if (attr == R.styleable.RunningRing_colorSecond) {
                mColorSecond = typedArray.getColor(attr, Color.BLUE);
            } else if (attr == R.styleable.RunningRing_speed) {
                mSpeed = typedArray.getInt(attr, 1);
            } else if (attr == R.styleable.RunningRing_ringWidth) {
                mRingWidth = typedArray.getDimensionPixelSize(attr, (int) TypedValue.applyDimension(
                        TypedValue.COMPLEX_UNIT_PX, 20, getResources().getDisplayMetrics()));
            }
        }
        typedArray.recycle();
        mPaint = new Paint();

        //绘图线程
//        new Thread() {
//            public void run() {
//                while (mProgress<=360) {
////                    mProgress++;
//                    if (mProgress == 360) {
//                        mProgress = 0;
////                        if (isNext) {
////                            isNext = false;
////                        } else {
////                            isNext = true;
////                        }
//                    }
//                    postInvalidate();
//                    try {
//                        Thread.sleep(mSpeed);
//                    } catch (InterruptedException e) {
//                        e.printStackTrace();
//                    }
//                }
//            }
//        }.start();
    }

    public void controlSpeed(int frameNum){

        mProgress = frameNum*24;


    }

    @Override
    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
        super.onMeasure(widthMeasureSpec, heightMeasureSpec);

    }

    @Override
    protected void onDraw(Canvas canvas) {
        int centre = getWidth() / 2;//圆心
        int radius = centre - mRingWidth / 2;//半径
        mPaint.setStyle(Paint.Style.STROKE);//空心圆
        mPaint.setStrokeWidth(mRingWidth);
        mPaint.setAntiAlias(true);
        RectF rectF = new RectF(centre - radius, centre - radius, centre + radius, centre + radius);

//        if (!isNext) {//第一颜色的圈完整，第二颜色跑
            mPaint.setColor(mColorFirst);
            canvas.drawCircle(centre, centre, radius, mPaint);// 画出圆环
            mPaint.setColor(mColorSecond);
            canvas.drawArc(rectF, -90, mProgress, false, mPaint);// 根据进度画圆弧
//        }
//        else {
//            mPaint.setColor(mColorSecond);
//            canvas.drawCircle(centre, centre, radius, mPaint);// 画出圆环
//            mPaint.setColor(mColorFirst);
//            canvas.drawArc(rectF, -90, mProgress, false, mPaint);// 根据进度画圆弧
//
//        }
        if(mProgress == 0){
            mPaint.setColor(mColorFirst);
            canvas.drawCircle(centre,centre,radius,mPaint);
            mPaint.setColor(mColorSecond);
            canvas.drawArc(rectF, -90, mProgress, false, mPaint);// 根据进度画圆弧

        }
        postInvalidate();
    }
}

